stages:
  - build
  - containerize

variables:
  IMAGE_NAME: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG

build:
  stage: build
  image: quay.io/quarkus/centos-quarkus-maven:21.0.0-java11
  script:
    - mvn -f $CI_PROJECT_DIR/pom.xml clean package
  artifacts:
    paths:
      - $CI_PROJECT_DIR/target/*-runner.jar
      - $CI_PROJECT_DIR/target/lib/*
      - $CI_PROJECT_DIR/target/quarkus-app/*

containerize:
  stage: containerize
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - >
      /kaniko/executor
      --context $CI_PROJECT_DIR
      --dockerfile $CI_PROJECT_DIR/src/main/docker/Dockerfile.jvm
      --destination $IMAGE_NAME
